﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Erettsegi18_Pitypang
{
    class Foglalás
    {
        public int sorszám;
        public int szoba;
        public int érkezés;
        public int távozás;
        public int fő;
        public bool reggeli;
        public string név;

        public Foglalás(string f)
        {
            sorszám = int.Parse(f.Split(' ')[0]);
            szoba = int.Parse(f.Split(' ')[1]);
            érkezés = int.Parse(f.Split(' ')[2]);
            távozás = int.Parse(f.Split(' ')[3]);
            fő = int.Parse(f.Split(' ')[4]);
            reggeli = f.Split(' ')[5] == "1" ? true : false;
            név = f.Split(' ')[6];
        }
        public int VendégÉjszaka(int sorszám) //Adott sorszámhoz tartozó éjszakák száma
        {
            if (sorszám >= érkezés && sorszám < távozás) return fő;
            return 0;
        }
        public int éjszakák { get { return távozás - érkezés; } }
        public int fizetendő
        {
            get
            {
                int szobaár = 9000;
                if (érkezés >= 121) szobaár = 10000;
                if (érkezés >= 244) szobaár = 8000;
                return éjszakák * szobaár + (fő > 2 ? 1 : 0) * 2000 * éjszakák + (reggeli ? 1 : 0) * éjszakák * fő * 1100;
            }
        }
    }
   
    class Pitypang
    {
        static void Main(string[] args)
        {
            Console.WriteLine("1. feladat: Beolvasás");
            string[] forrás = File.ReadAllLines("pitypang.txt");
            List<Foglalás> foglalások = new List<Foglalás>();
            for (int i = 1; i < forrás.Length; i++) foglalások.Add(new Foglalás(forrás[i]));

            Console.WriteLine("2. feladat: Leghosszabb szállodai tartozkodás:");
            var leghosszabb = foglalások.OrderByDescending(i => i.éjszakák).First();
            Console.WriteLine("{0} ({1}) - {2}", leghosszabb.név, leghosszabb.érkezés, leghosszabb.éjszakák);

            Console.WriteLine("3. feladat: Bevétel meghatározása");
            List<string> ki = new List<string>();
            foreach (var foglalás in foglalások) ki.Add(String.Join(":", foglalás.sorszám, foglalás.fizetendő));
            File.WriteAllLines("bevétel.txt", ki);
            Console.WriteLine("A szálloda éves bevétele: {0} Ft", foglalások.Sum(i => i.fizetendő));

            Console.WriteLine("4. feladat: Vendégéjszakák száma havonta:");
            int[] hónapok = new int[] { 1, 32, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366 };
            for (int i = 0; i < hónapok.Length-1; i++)
			{
                int vész=0; //vendégéjszakák száma
                foreach (Foglalás f in foglalások) for (int j = hónapok[i]; j <hónapok[i+1]; j++) vész += f.VendégÉjszaka(j);
                Console.WriteLine("{0}: {1} vendégéj", i+1, vész);
            }

            Console.WriteLine("5. feladat: Szabad szobák száma:");
            Console.Write("Kérem az érkezési nap sorszámát:");
            int érkezés = int.Parse(Console.ReadLine());
            Console.Write("Kérem az éjszakák számát:");
            int éjszakák = int.Parse(Console.ReadLine());
            int távozás = érkezés + éjszakák;
            var foglalt_szobák = foglalások.Where(i => i.érkezés < távozás && i.távozás > érkezés).GroupBy(i=>i.szoba).Count(); //Átfedi a foglalandó időszakot
            Console.Write("Szabad {0} db szoba!", 27-foglalt_szobák);
            Console.ReadKey();
        }
    }
}